Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1360240 - Fix potential buffer overrun in expr_evaluate_string()
Summary: Fix potential buffer overrun in expr_evaluate_string()
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: nftables
Version: 7.3
Hardware: Unspecified
OS: Unspecified
medium
medium
Target Milestone: rc
: ---
Assignee: Timothy Redaelli
QA Contact: Tomas Dolezal
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2016-07-26 10:19 UTC by Phil Sutter
Modified: 2017-08-01 18:56 UTC (History)
6 users (show)

Fixed In Version: nftables-0.6-3.el7
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-08-01 18:56:07 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2017:2047 normal SHIPPED_LIVE nftables bug fix and enhancement update 2017-08-01 18:13:06 UTC

Description Phil Sutter 2016-07-26 10:19:51 UTC
As reported by covscan:


1. nftables-0.6/src/evaluate.c:264: unsigned_compare: This greater-than-or-equal-to-zero comparison of an unsigned value is always true. "datalen - 1U >= 0U".
#   262|   	}
#   263|   
#   264|-> 	if (datalen - 1 >= 0 &&
#   265|   	    data[datalen - 1] == '\\') {
#   266|   		char unescaped_str[data_len];


It looks like 'datalen' really should be signed. Further above it is initialized with 'datalen = strlen(data) - 1', so it may indeed become negative.

There is another problematic line of code in between initialization and covscan reported area: 'if (data[datalen] != '*') {'. This might access unallocated memory as well.

Comment 2 Phil Sutter 2016-09-08 13:27:29 UTC
After some discussion upstream, the issue seems not as severe as assumed at first. Yet, it resulted in the following commit which should be backported on behalf of this ticket:

commit 7a5b4c505e4d460239ac8a36b4fbccf222cd6134
Author: Phil Sutter <phil@nwl.cc>
Date:   Tue Aug 30 19:39:49 2016 +0200

    evaluate: Fix datalen checks in expr_evaluate_string()
    
    I have been told that the flex scanner won't return empty strings, so
    strlen(data) should always be greater 0. To avoid a hard to debug issue
    though, add an assert() to make sure this is always the case before
    risking an unsigned variable underrun.
    
    A real issue though is the check for 'datalen - 1 >= 0', which will
    never fail due to datalen being unsigned. Fix this by incrementing both
    sides by one, hence checking 'datalen >= 1'.
    
    Signed-off-by: Phil Sutter <phil@nwl.cc>
    Signed-off-by: Pablo Neira Ayuso <pablo@netfilter.org>

Comment 5 Timothy Redaelli 2017-03-02 15:24:06 UTC
Cherry-picked 7a5b4c505e4d460239ac8a36b4fbccf222cd6134

Comment 8 errata-xmlrpc 2017-08-01 18:56:07 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHBA-2017:2047


Note You need to log in before you can comment on or make changes to this bug.